config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'home#index'

  resources :users, only: [:show] do
  	get 'shared_projects', on: :member
	  resources :projects, only: [:index, :new, :create]
    resources :trashes, only: [:index]
    resources :notifications, only: [:index, :destroy]
  end

  resources :projects, only: [:show, :edit, :update, :destroy] do
  	resources :tasks, only: [:new, :create, :index]
  	resources :contributors, only: [:new, :create, :index, :destroy]

    resources :links, only: [:new, :create] do
      get 'unlink', on: :member
    end

    resources :trashes, only: [:create] do
      collection { post 'restore', to: 'trashes#restore' }
    end
  end

  resources :tasks, only: [:edit, :update, :show] do
    resources :assignees, only: [:new, :create]
    post 'start', to: 'task_states#start'
    post 'ready', to: 'task_states#ready'
    post 'finish', to: 'task_states#finish'
    post 'accept', to: 'task_states#accept'
    post 'schedule', to: 'task_states#schedule'
    post 'stop', to: 'task_states#stop'
    post 'continue', to: 'task_states#continue'
    post 'verify', to: 'task_states#verify'
    post 'reject', to: 'task_states#reject'
    post 'discard', to: 'task_states#discard'
  end

  resources :links, only: [:destroy]
end

app/models/project.rb
# frozen_string_literal: true
class Project < ApplicationRecord
  include ActiveModel::Validations

  validates :name, presence: true
  validates :starting_date, presence: true
  validates :ending_date, presence: true

  belongs_to :user
  has_many :tasks, dependent: :destroy
  has_many :task_reports, dependent: :destroy

  has_many :project_contributors, dependent: :destroy
  has_many :contributors, through: :project_contributors,
                          source: :user,
                          dependent: :destroy

  alias_attribute :owner, :user
end

app/controllers/projects_controller.rb
# frozen_string_literal: true
class ProjectsController < ApplicationController
  layout :default_layout

  before_action :authenticate_user!, except: [:show, :index]
  before_action :find_project, only: [:edit, :update, :show, :destroy]
  before_action :find_notifications

  def index
    @projects = current_user
      .projects
      .where(in_trash: false)
      .map { |project| TimeDisplayPresenter.new(project) }
  end

  def new
    @project = Project.new
  end

  def create
    @project = current_user.projects.build(project_params)

    if valid_deadline? && @project.save
      flash[:notice] = I18n.t('project.created.success')

      redirect_to project_path(@project)
    else
      flash[:alert] = I18n.t('project.created.failure')

      render 'new', layout: 'logged_layout'
    end
  end

  def show
    validate_entry!(@project)
    @project = TimeDisplayPresenter.new(@project)
    @tasks = @project.tasks.map { |task| TimeDisplayPresenter.new(task) }
  end

  def edit; end

  def update
    validate_ownership!(@project)
    if ProjectUpdater.new(@project).update(project_params)
      flash[:notice] = I18n.t('project.updated.success')

      redirect_to project_path(@project)
    else
      flash[:alert] = I18n.t('project.updated.failure')

      render 'edit'
    end
  end

  def destroy
    validate_ownership!(@project)

    @project.destroy

    redirect_to user_trashes_path(current_user),
                notice: I18n.t('project.deleted.success', name: @project.name)
  end

  private

  def project_params
    params.require(:project)
          .permit(:name, :ending_date, :starting_date)
  end

  def find_project
    @project = Project.find params[:id]
  rescue ActiveRecord::RecordNotFound
    render status: 404, file: 'public/404.html'
  end

  def valid_deadline?
    hash = @project
      .attributes
      .merge(errors: @project.errors, name: 'project')
      .with_indifferent_access

    ValidatorRunner.new(hash, [
      MissingDeadlines,
      StartingDateBeforeToday,
      EndingDateBeforeToday,
      EndingBeforeStarting
    ]).valid?
  end

  def default_layout
    return 'logged_layout' if ['index', 'new'].include? action_name
    'project'
  end
end

app/views/projects/_form.html.erb
<% if project.errors.any? %>
	<div class='errors'>
		<ul>
			<% project.errors.full_messages.each do |error| %>
				<li><%= error %></li>
			<% end %>
		</ul>
	</div>
<% end %>

<div class="col-md-6 col-md-offset-3 col-sm-8 col-sm-offset-2 col-xs-10 col-xs-offset-1">
  <div class="row">
    <div class="text-center">
      <h1><%= title_text %></h1>
      <hr>
    </div>
  </div>

  <%= form_for project, url: url, html: { class: 'form-horizontal' } do |f| %>
    <fieldset class="form-group">
      <%= f.label :name, class: 'col-sm-2 control-label' %>
      <div class="col-sm-10">
        <%= f.text_field :name, class: 'form-control', placeholder: 'My project',
          required: true %>
      </div>
    </fieldset>

    <fieldset class="form-group">
      <%= f.label :starting_date, class: 'col-sm-2 control-label' %>
      <div class="col-sm-10">
      <%= f.date_field :starting_date, class: 'form-control',
                       :value => Time.zone.now.strftime('%Y-%m-%d')  %>
      </div>
    </fieldset>

    <fieldset class="form-group">
      <%= f.label :ending_date, class: 'col-sm-2 control-label' %>
      <div class="col-sm-10">
      <%= f.date_field :ending_date, class: 'form-control',
                       :value => 1.day.from_now.strftime('%Y-%m-%d')  %>
      </div>
    </fieldset>

    <div class="text-center">
      <fieldset class="btn-group">
        <%= f.submit button_text, id: 'submit', class: 'btn btn-primary btn-lg' %>
      </fieldset>
    </div>
  <% end %>
</div>

app/views/projects/_no_project.html.erb
<section class="row">
  <div class="col-md-8 col-md-offset-2 col-sm-10 col-sm-offset-1 col-xs-10 col-xs-offset-1">
    <div class="text-center">
      <h3><%= t('user.no_project') %></h3>

      <br />
      <%= link_to t('project.new'),
        new_user_project_path(current_user),
        id: 'new_project',
        class: 'btn btn-primary btn-lg' %>
    </div>
  </div>
</section>

app/views/projects/_project.html.erb
<div id='project-<%= project.id %>' class="col-md-4 col-md-offset-0 col-sm-6 col-sm-offset-0 col-xs-10 col-xs-offset-1">
  <div class="panel panel-default">
    <div class="text-center">
      <div class="panel-body">
        <%= render partial: 'project_summary', locals: {project: project} %>
      </div>

      <div class="panel-footer">
        <div class='btn-group'>
          <%= link_to t('project.edit'), 
            edit_project_path(project.id),
            id: 'edit_project', class: 'btn btn-primary' %>
          <%= button_to t('project.trash'),
            project_trashes_path(project.id),
            id: 'move_to_trash', 
            class: 'btn btn-primary',
            form_class: 'form-inline' %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/projects/_project_summary.html.erb
<div class="row">
  <h4> <%= link_to project.name, project_path(project.id) %> </h4>
  <p><%= project.time_remaining %></p>
</div>

app/views/projects/edit.html.erb
<%= render partial: 'shared/alerts' %>
<%= render partial: 'form', locals: { 
	project: @project, 
	url: project_path(@project),
  button_text: t('project.save'),
  title_text: t('project.edit')} %>

app/views/projects/index.html.erb

<article id='my_projects'>
  <header class="row">
    <div class='text-center'>
      <h1><%= t('user.projects') %></h1>
      <hr>
    </div>
  </header>

  <div class="row">
    <% flash.each do |name, msg| %>
      <%= content_tag :div, msg, class: 'alert alert-info' %>
    <% end %>
  </div>

  <% if @projects.empty? %>
    <%= render partial: 'no_project' %>
  <% else %>
    <div class="row">
      <%= render @projects %>
    </div>
  <% end %>
</article>

app/views/projects/new.html.erb
<%= render partial: 'shared/alerts' %>
<%= render partial: 'form', locals: {
	project: @project, 
	url: user_projects_path(current_user, @project),
  button_text: t('project.create'),
  title_text: t('project.new')} %>

app/views/projects/show.html.erb
<header class="row">
  <div class="col-md-offset-2 col-sm-offset-1 col-xs-offset-1">
    <h1><%= @project.name %></h1><br />
    <h5 id='time_remaining'><%= @project.time_remaining %></h5>
    <h5 id='starting_time'><%= @project.starting_date %></h5>
  </div>
</header>
<hr>

<%= render partial: 'shared/notices' %>

<article class="row">
  <div class="col-md-3 col-sm-6 col-xs-12">
    <%= link_to project_tasks_path(@project), class: 'btn btn-default', id: 'project_tasks' do %>
      <%= image_tag 'tasks.png', class: 'img-responsive' %>
      <h4><%= t('project.tasks') %></h4>
    <% end %>
  </div>

  <% if current_user == @project.owner %>
    <div class="col-md-3 col-sm-6 col-xs-12">
      <%= link_to project_contributors_path(@project), class: 'btn btn-default', id: 'project_contributors' do %>
        <%= image_tag 'contributors.png', class: 'img-responsive' %>
        <h4><%= t('project.contributors') %></h4>
      <% end %>
    </div>
  <% end %>
</article>